﻿namespace WCS.WorkEngineering.WebApi.Models.AGV.Request
{
    /// <summary>
    ///  取消任务
    /// </summary>
    public class CancelTaskRequest
    {
        /// <summary>
        ///  请求编号
        /// </summary>
        public string reqCode { get; set; }

        /// <summary>
        ///  求时间截 格式: “yyyy-MM-dd HH:mm:ss”。
        /// </summary>
        public string reqTime { get; set; }

        /// <summary>
        ///  客户端编号，如PDA，HCWMS等。
        /// </summary>
        public string clientCode { get; set; }

        /// <summary>
        ///  令牌号, 由调度系统颁发
        /// </summary>
        public string tokenCode { get; set; }

        /// <summary>
        ///  取消类型 0表示：取消后货架直接放地上
        ///  1表示：AGV仍然背着货架， 根据回库区域执行回库指令， 只有潜伏车和CTU车支持。
        ///  默认的取消模式为0
        /// </summary>
        public string forceCancel { get; set; }

        /// <summary>
        ///  forcecancel=1时有意义，回库区域编号， 如果为空，采用货架配置的库区。
        /// </summary>
        public string matterArea { get; set; }

        /// <summary>
        ///  取消该AGV正在执行的任务单
        /// </summary>
        public string agvCode { get; set; }

        /// <summary>
        /// 任务单编号, 取消该任务单
        /// </summary>
        public string taskCode { get; set; }
    }
}
